﻿using System;
using System.ComponentModel;
using JetBrains.Annotations;
using OpcLabs.BaseLib.ComponentModel.Referencing;

namespace OpcLabs.BaseLibFactory.ComponentModel
{
    static public class ValueTargetInstances
    {
        [Serializable]
        private class TestExtenderProvider : IExtenderProvider
        {
            // ReSharper disable once UnusedParameter.Local
            // ReSharper disable once MemberCanBeMadeStatic.Local
            private bool Equals(TestExtenderProvider other)
            {
                return true;
            }

            public override bool Equals(object obj)
            {
                if (ReferenceEquals(null, obj)) return false;
                if (ReferenceEquals(this, obj)) return true;
                // ReSharper disable once ConvertIfStatementToReturnStatement
                if (obj.GetType() != /*this.*/GetType()) return false;
                return Equals((TestExtenderProvider) obj);
            }

            /// <inheritdoc cref="object.GetHashCode()"/>
            public override int GetHashCode()
            {
                return 0;
            }

            public bool CanExtend(object extendee)
            {
                throw new NotImplementedException();
            }
        }

        [NotNull]
        static public ValueTarget Instance0 => new ValueTarget();

        [NotNull]
        static public ValueTarget Instance1 => new ValueTarget(null, "testTargetPath1", null);

        [NotNull]
        static public ValueTarget Instance2 => new ValueTarget(new TestComponent(), "", null);

        [NotNull]
        static public ValueTarget Instance3 => new ValueTarget(null, "", new TestExtenderProvider());

        [NotNull]
        static public ValueTarget Instance4 => new ValueTarget(new TestComponent(), "testTargetPath1", new TestExtenderProvider());

        [NotNull]
        static public ValueTarget Instance5 => new ValueTarget(new TestComponent(), "element1.element2.element3", new TestExtenderProvider());
    }
}
