﻿
using System;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace OpcLabs.UnitTestLib
{
    static public class IServiceProviderTest
    {
        static public void GetServiceTest(
            [NotNull] IServiceProvider serviceProvider,
            [NotNull] Type serviceType)
        {
            GetServiceTest(serviceProvider, serviceType, serviceType);
        }

        static public void GetServiceTest(
            [NotNull] IServiceProvider serviceProvider,
            [NotNull] Type serviceType,
            [NotNull] Type objectType)
        {
            TestSection.Act();
            object serviceObject = serviceProvider.GetService(serviceType);

            TestSection.Assert();
            Assert.IsNotNull(serviceObject);
            Assert.IsInstanceOfType(serviceObject, objectType);
        }

        static public void GetServiceTest_Negative(
            [NotNull] IServiceProvider serviceProvider,
            [NotNull] Type serviceType)
        {
            TestSection.Act();
            object serviceObject = serviceProvider.GetService(serviceType);

            TestSection.Assert();
            Assert.IsNull(serviceObject);
        }
    }
}
