﻿using System.Collections.ObjectModel;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace OpcLabs.UnitTestLib
{
    public abstract class TestMethod
    {
        #region Protected Constructors

        protected TestMethod([NotNull] string name)
        {
            Name = name;
            TestCategoryAttributes = new Collection<TestCategoryAttribute>();
        }

        #endregion



        #region Public Properties

        [CanBeNull]
        public IgnoreAttribute IgnoreAttribute { get; set; }

        [NotNull]
        public string Name { get; }

        [NotNull]
        public Collection<TestCategoryAttribute> TestCategoryAttributes { get; }

        [CanBeNull]
        public TimeoutAttribute TimeoutAttribute { get; set; }

        #endregion



        #region Public Methods

        public abstract void Test();

        #endregion
    }
}
