﻿using System;
using JetBrains.Annotations;

namespace OpcLabs.UnitTestLib.Testers
{
    public class DefaultCtorTester : Tester
    {
        public DefaultCtorTester() 
        {
            TestCategories.Add("Construction");
        }

        [NotNull]
        static private TestMethod CreateConstructorTestMethod([NotNull] Type typeUnderTest)
        {
            return new DelegatedTestMethod("DefaultCtor", () => Activator.CreateInstance(typeUnderTest, nonPublic: true));
        }

        protected override void Initialize(Type typeUnderTest)
        {
            base.Initialize(typeUnderTest);

            AddTestMethod(CreateConstructorTestMethod(typeUnderTest));
        }
    }
}
