﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace OpcLabs.BaseLibTest.Platform
{
    [TestClass]
    public class UriBuilderTest
    {
        [TestMethod]
        public void ToStringTest1()
        {
            var target = new UriBuilder {Path = "testPath"};
            Assert.AreEqual("http://localhost/testPath", target.ToString());
        }

        [TestMethod]
        public void ToStringTest2()
        {
            var target = new UriBuilder { Scheme = "unknown", Path = "testPath" };
            Assert.AreEqual("unknown://localhost/testPath", target.ToString());
        }

        [TestMethod]
        public void ToStringTest3()
        {
            var target = new UriBuilder { Scheme = "unknown", Host = "", Path = "testPath" };
            Assert.AreEqual("unknown:testPath", target.ToString());
        }

        [TestMethod]
        public void ToStringTest4()
        {
            var target = new UriBuilder { Host = "", Path = "testPath" };
            Assert.AreEqual("http://testPath", target.ToString());
        }
    }
}
