﻿
using System.Collections.Generic;
using System.Linq;
using JetBrains.Annotations;

namespace OpcLabs.EasyOpcLiveTest.DataAccess.Environment
{
    static class IEnumerableOfDAItemCatalogEntryExtension
    {
        [NotNull]
        static public IEnumerable<DAItemCatalogEntry> NonReadables([NotNull] this IEnumerable<DAItemCatalogEntry> source)
        {
            // ReSharper disable once PossibleNullReferenceException
            return source.Where(entry => !entry.AccessRights.AllowRead);
        }

        [NotNull]
        static public IEnumerable<DAItemCatalogEntry> Readables([NotNull] this IEnumerable<DAItemCatalogEntry> source)
        {
            // ReSharper disable once PossibleNullReferenceException
            return source.Where(entry => entry.AccessRights.AllowRead);
        }

        [NotNull]
        static public IEnumerable<DAItemCatalogEntry> ReadWriteables([NotNull] this IEnumerable<DAItemCatalogEntry> source)
        {
            // ReSharper disable once PossibleNullReferenceException
            return source.Where(entry => entry.AccessRights.AllowRead && entry.AccessRights.AllowWrite);
        }
    }
}
