﻿using System.ComponentModel;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess
{
    partial class EasyDAClientConfigurationTest
    {
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void DefaultValueTest_ServiceProviderEndpointDescriptor()
        {
            var target = new EasyDAClientConfiguration();

            EndpointDescriptor endpointDescriptor = target.ServiceProviderEndpointDescriptor;
            Assert.IsNotNull(endpointDescriptor);
            AssertUtilities.WriteLine(endpointDescriptor);
            Assert.IsFalse(endpointDescriptor.IsNull);
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void DefaultValueTest_ServiceProviderEndpointDescriptor_2()
        {
            var target = new EasyDAClientConfiguration(new Container());

            EndpointDescriptor endpointDescriptor = target.ServiceProviderEndpointDescriptor;
            Assert.IsNotNull(endpointDescriptor);
            AssertUtilities.WriteLine(endpointDescriptor);
            Assert.IsFalse(endpointDescriptor.IsNull);
        }
    }
}
