﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.Discovery;
using OpcLabs.EasyOpcFactory.UA.Discovery;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.Discovery
{
    public partial class UADiscoveryElementCollectionTest
    {
        #region Test Methods

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        #endregion



        #region Private Methods

        [NotNull]
        private UADiscoveryElementCollection CreateSerializationTarget0()
        {
            return new UADiscoveryElementCollection();
        }

        [NotNull]
        private UADiscoveryElementCollection CreateSerializationTarget1()
        {
            var discoveryElementCollection = new UADiscoveryElementCollection
                                              {
                                                  UADiscoveryElementInstances.Instance0,
                                                  UADiscoveryElementInstances.Instance1
                                              };
            return discoveryElementCollection;
        }

        #endregion
    }
}
