﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.Engine;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.Engine
{
    public partial class EasyUASharedParametersTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        static public EasyUASharedParameters CreateSerializationTarget0()
        {
            return new EasyUASharedParameters();
        }

        [NotNull]
        static public EasyUASharedParameters CreateSerializationTarget1()
        {
            return new EasyUASharedParameters(EasyUAEngineParametersTest.CreateSerializationTarget1());
        }
    }
}
